#!/usr/bin/perl
use Time::HiRes qw(usleep nanosleep);
local $| = 1;

$fname=$ARGV[0];
$cols=`identify -format "%w" $fname`;
$vname=`identify -format "%t" $fname`;
chomp($vname);

$str=`convert -flip $fname - | stream -colorspace RGB -storage-type char - -`;

$fname=~/(.+?)\.bmp/;
$fout=$1.".inc";
open(FD,">",$fout);

@a=unpack("C*",$str);
$ind=0;
$b=0;
$line=0;
@out=();
$rows=int(($#a+1)/(3*8*$cols));
printf("%s\n",$fout);


#printf("%dx%d\n",$cols,$rows);
$crow=0;
if ($rows>1) {printf(FD "{");}
while ($ind<=$#a) {
    $summ=$a[$ind++]|$a[$ind++]|$a[$ind++];
    $pix=$summ>100?0:1;
    $out[$line]|=($pix<<($b));
    $line++;
    if ($line>=$cols) {
	$b++;
	if ($b>=8) {
	    $b=0;
	    print FD "{";
	    for ($i=0;$i<$cols;$i++) {
		printf(FD "0x%02X",$out[$i]);
		if ($i<($cols-1)) {print FD ",";}
		}
	    $crow++;
	    if ($crow<$rows) {print FD "},\n";}else{print FD "}";}
	    @out=();
	    }
	$line=0;
    }
}
if ($b!=0) {
    print FD "{";
    for ($i=0;$i<$cols;$i++) {
	printf(FD "0x%02X",$out[$i]);
	if ($i<($cols-1)) {print FD ",";}
	}
    print FD "}";
}
if ($rows>1) {print FD "},\n\n";} else{print FD ",\n\n";}
exit 0;



#    for ($b=8;$b>0;$b--) {
#        for($j=0;$j<$cols;$j++) {
#            $summ=$a[$ind++]|$a[$ind++]|$a[$ind++];
#	    $pix=$summ>100?0:1;
#    	    $out[$j]|=($pix<<(8-$b));
#	    }
#	}
#    for ($j=0;$j<$cols;$j++) {
#	printf("%02x",$out[$j]);
#	}
#	print "\n";
